=== modified file 'drizzled/atomic/sun_studio.h'
--- drizzled/atomic/sun_studio.h	2009-08-30 00:26:17 +0000
+++ drizzled/atomic/sun_studio.h	2010-04-01 16:41:45 +0000
@@ -24,91 +24,177 @@
 #include <atomic.h>
 #undef _KERNEL
 
+inline bool __sync_fetch_and_add(volatile bool* ptr, bool val)
+{
+  bool ret= *ptr;
+  (val == true) ? atomic_inc_8((volatile uint8_t *)ptr) : atomic_add_8((volatile uint8_t *)ptr, (int8_t)val);
+  return ret;
+}
+ 
+inline int8_t __sync_fetch_and_add(volatile int8_t* ptr, int8_t val)
+{
+  int8_t ret= *ptr; 
+  (val == 1) ? atomic_inc_8((volatile uint8_t*)ptr) : atomic_add_8((volatile uint8_t*)ptr, val);
+  return ret;
+}
+
+inline int16_t __sync_fetch_and_add(volatile int16_t* ptr, int16_t val)
+{
+  int16_t ret= *ptr;
+  (val == 1) ? atomic_inc_16((volatile uint16_t*)ptr) : atomic_add_16((volatile uint16_t*)ptr, val);
+  return ret;
+}
+
+inline int32_t __sync_fetch_and_add(volatile int32_t* ptr, int32_t val)
+{
+  int32_t ret= *ptr;
+  (val == 1) ? atomic_inc_32((volatile uint32_t*)ptr) : atomic_add_32((volatile uint32_t*)ptr, val);
+  return ret;
+}
+
+inline uint8_t __sync_fetch_and_add(volatile uint8_t* ptr, uint8_t val)
+{
+  uint8_t ret= *ptr;
+  (val == 1) ? atomic_inc_8(ptr) : atomic_add_8(ptr, (int8_t)val);
+  return ret;
+}
+
+inline uint16_t __sync_fetch_and_add(volatile uint16_t* ptr, uint16_t val)
+{
+  uint16_t ret= *ptr;
+  (val == 1) ? atomic_inc_16(ptr) : atomic_add_16(ptr, (int16_t)val);
+  return ret;
+}
+
+inline uint32_t __sync_fetch_and_add(volatile uint32_t* ptr, uint32_t val)
+{
+  uint32_t ret= *ptr;
+  (val == 1) ? atomic_inc_32(ptr) : atomic_add_32(ptr, (int32_t)val);
+  return ret;
+}
+
+# if defined(_KERNEL) || defined(_INT64_TYPE)
+inline uint64_t __sync_fetch_and_add(volatile uint64_t* ptr, uint64_t val)
+{
+  uint64_t ret= *ptr;
+  (val == 1) ? atomic_inc_64(ptr) : atomic_add_64(ptr, (int64_t)val);
+  return ret;
+}
+
+inline int64_t __sync_fetch_and_add(volatile int64_t* ptr, int64_t val)
+{
+  int64_t ret= *ptr;
+  (val == 1) ? atomic_inc_64((volatile uint64_t*)ptr) : atomic_add_64((volatile uint64_t*)ptr, val);
+  return ret;
+}
+# endif /* defined(_KERNEL) || defined(_INT64_TYPE) */
+
+inline uint8_t __sync_fetch_and_sub(volatile uint8_t* ptr, uint8_t val)
+{
+  uint8_t ret= *ptr;
+  (val == 1) ? atomic_dec_8(ptr) : atomic_add_8(ptr, 0-(int8_t)val);
+  return ret;
+}
+
+inline uint16_t __sync_fetch_and_sub(volatile uint16_t* ptr, uint16_t val)
+{
+  uint16_t ret= *ptr;
+  (val == 1) ? atomic_dec_16(ptr) : atomic_add_16(ptr, 0-(int16_t)val);
+  return ret;
+}
+
+inline uint32_t __sync_fetch_and_sub(volatile uint32_t* ptr, uint32_t val)
+{
+  uint32_t ret= *ptr;
+  (val == 1) ? atomic_dec_32(ptr) : atomic_add_32(ptr, 0-(int32_t)val);
+  return ret;
+}
+
+# if defined(_KERNEL) || defined(_INT64_TYPE)
+inline uint64_t __sync_fetch_and_sub(volatile uint64_t* ptr, uint64_t val)
+{
+  uint64_t ret= *ptr;
+  (val == 1) ? atomic_dec_64(ptr) : atomic_add_64(ptr, 0-(int64_t)val);
+  return ret;
+}
+inline int64_t __sync_fetch_and_sub(volatile int64_t* ptr, uint64_t val)
+{
+  int64_t ret= *ptr;
+  (val == 1) ? atomic_dec_64((volatile uint64_t *) ptr) : atomic_add_64((volatile uint64_t *) ptr, 0-(int64_t)val);
+  return ret;
+}
+# endif /* defined(_KERNEL) || defined(_INT64_TYPE) */
+
 inline bool __sync_add_and_fetch(volatile bool* ptr, bool val)
 {
-  (val == true) ? atomic_inc_8((volatile uint8_t *)ptr) : atomic_add_8((volatile uint8_t *)ptr, (int8_t)val);
-  return *ptr;
+  return (val == true) ? atomic_inc_8_nv((volatile uint8_t *)ptr) : atomic_add_8_nv((volatile uint8_t *)ptr, (int8_t)val);
 }
  
 inline int8_t __sync_add_and_fetch(volatile int8_t* ptr, int8_t val)
 {
-  (val == 1) ? atomic_inc_8((volatile uint8_t*)ptr) : atomic_add_8((volatile uint8_t*)ptr, val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_8_nv((volatile uint8_t*)ptr) : atomic_add_8_nv((volatile uint8_t*)ptr, val);
 }
 
 inline int16_t __sync_add_and_fetch(volatile int16_t* ptr, int16_t val)
 {
-  (val == 1) ? atomic_inc_16((volatile uint16_t*)ptr) : atomic_add_16((volatile uint16_t*)ptr, val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_16_nv((volatile uint16_t*)ptr) : atomic_add_16_nv((volatile uint16_t*)ptr, val);
 }
 
 inline int32_t __sync_add_and_fetch(volatile int32_t* ptr, int32_t val)
 {
-  (val == 1) ? atomic_inc_32((volatile uint32_t*)ptr) : atomic_add_32((volatile uint32_t*)ptr, val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_32_nv((volatile uint32_t*)ptr) : atomic_add_32_nv((volatile uint32_t*)ptr, val);
 }
 
 inline uint8_t __sync_add_and_fetch(volatile uint8_t* ptr, uint8_t val)
 {
-  (val == 1) ? atomic_inc_8(ptr) : atomic_add_8(ptr, (int8_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_8_nv(ptr) : atomic_add_8_nv(ptr, (int8_t)val);
 }
 
 inline uint16_t __sync_add_and_fetch(volatile uint16_t* ptr, uint16_t val)
 {
-  (val == 1) ? atomic_inc_16(ptr) : atomic_add_16(ptr, (int16_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_16_nv(ptr) : atomic_add_16_nv(ptr, (int16_t)val);
 }
 
 inline uint32_t __sync_add_and_fetch(volatile uint32_t* ptr, uint32_t val)
 {
-  (val == 1) ? atomic_inc_32(ptr) : atomic_add_32(ptr, (int32_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_32_nv(ptr) : atomic_add_32_nv(ptr, (int32_t)val);
 }
 
 # if defined(_KERNEL) || defined(_INT64_TYPE)
 inline uint64_t __sync_add_and_fetch(volatile uint64_t* ptr, uint64_t val)
 {
-  (val == 1) ? atomic_inc_64(ptr) : atomic_add_64(ptr, (int64_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_64_nv(ptr) : atomic_add_64_nv(ptr, (int64_t)val);
 }
 
 inline int64_t __sync_add_and_fetch(volatile int64_t* ptr, int64_t val)
 {
-  (val == 1) ? atomic_inc_64((volatile uint64_t*)ptr) : atomic_add_64((volatile uint64_t*)ptr, val);
-  return *ptr;
+  return (val == 1) ? atomic_inc_64_nv((volatile uint64_t*)ptr) : atomic_add_64_nv((volatile uint64_t*)ptr, val);
 }
 # endif /* defined(_KERNEL) || defined(_INT64_TYPE) */
 
-
 inline uint8_t __sync_sub_and_fetch(volatile uint8_t* ptr, uint8_t val)
 {
-  (val == 1) ? atomic_dec_8(ptr) : atomic_add_8(ptr, 0-(int8_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_dec_8_nv(ptr) : atomic_add_8_nv(ptr, 0-(int8_t)val);
 }
 
 inline uint16_t __sync_sub_and_fetch(volatile uint16_t* ptr, uint16_t val)
 {
-  (val == 1) ? atomic_dec_16(ptr) : atomic_add_16(ptr, 0-(int16_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_dec_16_nv(ptr) : atomic_add_16_nv(ptr, 0-(int16_t)val);
 }
 
 inline uint32_t __sync_sub_and_fetch(volatile uint32_t* ptr, uint32_t val)
 {
-  (val == 1) ? atomic_dec_32(ptr) : atomic_add_32(ptr, 0-(int32_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_dec_32_nv(ptr) : atomic_add_32_nv(ptr, 0-(int32_t)val);
 }
 
 # if defined(_KERNEL) || defined(_INT64_TYPE)
 inline uint64_t __sync_sub_and_fetch(volatile uint64_t* ptr, uint64_t val)
 {
-  (val == 1) ? atomic_dec_64(ptr) : atomic_add_64(ptr, 0-(int64_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_dec_64_nv(ptr) : atomic_add_64_nv(ptr, 0-(int64_t)val);
 }
 inline int64_t __sync_sub_and_fetch(volatile int64_t* ptr, uint64_t val)
 {
-  (val == 1) ? atomic_dec_64((volatile uint64_t *) ptr) : atomic_add_64((volatile uint64_t *) ptr, 0-(int64_t)val);
-  return *ptr;
+  return (val == 1) ? atomic_dec_64_nv((volatile uint64_t *) ptr) : atomic_add_64_nv((volatile uint64_t *) ptr, 0-(int64_t)val);
 }
 # endif /* defined(_KERNEL) || defined(_INT64_TYPE) */
 
@@ -175,4 +261,41 @@
 }
 #endif /* defined(_KERNEL) || defined(_INT64_TYPE) */
 
+inline int8_t __sync_bool_compare_and_swap(volatile int8_t* ptr,
+                                           int8_t old_val, int8_t val)
+{
+  int8_t orig= *ptr;
+  return orig == atomic_cas_8((volatile uint8_t *)ptr, old_val, val);
+}
+
+inline uint8_t __sync_bool_compare_and_swap(volatile uint8_t* ptr,
+                                           uint8_t old_val, uint8_t val)
+{
+  uint8_t orig= *ptr;
+  return orig == atomic_cas_8(ptr, old_val, val);
+}
+
+inline uint16_t __sync_bool_compare_and_swap(volatile uint16_t* ptr,
+                                            uint16_t old_val, uint16_t val)
+{
+  uint16_t orig= *ptr;
+  return orig == atomic_cas_16(ptr, old_val, val);
+}
+
+inline uint32_t __sync_bool_compare_and_swap(volatile uint32_t* ptr,
+                                            uint32_t old_val, uint32_t val)
+{
+  uint32_t orig= *ptr;
+  return orig == atomic_cas_32(ptr, old_val, val);
+}
+
+# if defined(_KERNEL) || defined(_INT64_TYPE)
+inline uint64_t __sync_bool_compare_and_swap(volatile uint64_t* ptr,
+                                            uint64_t old_val, uint64_t val)
+{
+  uint64_t orig= *ptr;
+  return orig == atomic_cas_64(ptr, old_val, val);
+}
+#endif /* defined(_KERNEL) || defined(_INT64_TYPE) */
+
 #endif /* DRIZZLED_ATOMIC_SUN_STUDIO_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-03-22 17:38:58 +0000
+++ drizzled/include.am	2010-04-01 16:41:45 +0000
@@ -308,6 +308,7 @@
 			      drizzled/plugin/query_cache.h \
 		              drizzled/plugin/query_rewrite.h \
 			      drizzled/plugin/registry.h \
+			      drizzled/plugin/replication.h \
 			      drizzled/plugin/scheduler.h \
 			      drizzled/plugin/storage_engine.h \
 			      drizzled/plugin/table_function.h \

=== added file 'plugin/transaction_log/tests/r/ddl_transaction_id.result'
--- plugin/transaction_log/tests/r/ddl_transaction_id.result	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/r/ddl_transaction_id.result	2010-04-01 16:41:45 +0000
@@ -0,0 +1,36 @@
+SET GLOBAL transaction_log_truncate_debug= true;
+DROP TABLE IF EXISTS t1;
+CREATE TABLE t1 (
+id INT NOT NULL PRIMARY KEY
+, padding VARCHAR(200) NOT NULL
+);
+INSERT INTO t1 VALUES (1, "I love testing.");
+INSERT INTO t1 VALUES (2, "I hate testing.");
+SELECT * FROM t1;
+id	padding
+1	I love testing.
+2	I hate testing.
+ALTER TABLE t1 CHANGE COLUMN padding less_padding VARCHAR(180) NOT NULL;
+SELECT * FROM t1 WHERE id = 3;
+id	less_padding
+DROP TABLE t1;
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG;
+FILE_NAME	FILE_LENGTH	NUM_LOG_ENTRIES	NUM_TRANSACTIONS	MIN_TRANSACTION_ID	MAX_TRANSACTION_ID	MIN_END_TIMESTAMP	MAX_END_TIMESTAMP	INDEX_SIZE_IN_BYTES
+transaction.log	X	6	6	1	6	X	X	X
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_ENTRIES;
+ENTRY_OFFSET	ENTRY_TYPE	ENTRY_LENGTH
+X	TRANSACTION	X
+X	TRANSACTION	X
+X	TRANSACTION	X
+X	TRANSACTION	X
+X	TRANSACTION	X
+X	TRANSACTION	X
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
+ENTRY_OFFSET	TRANSACTION_ID	SERVER_ID	START_TIMESTAMP	END_TIMESTAMP	NUM_STATEMENTS	CHECKSUM
+X	1	1	X	X	1	0
+X	2	1	X	X	1	0
+X	3	1	X	X	1	0
+X	4	1	X	X	1	0
+X	5	1	X	X	1	0
+X	6	1	X	X	1	0
+SET GLOBAL transaction_log_truncate_debug= true;

=== added file 'plugin/transaction_log/tests/t/ddl_transaction_id-master.opt'
--- plugin/transaction_log/tests/t/ddl_transaction_id-master.opt	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/ddl_transaction_id-master.opt	2010-04-01 16:41:45 +0000
@@ -0,0 +1,1 @@
+--default-replicator-enable --transaction-log-enable --scheduler=multi_thread

=== added file 'plugin/transaction_log/tests/t/ddl_transaction_id.inc'
--- plugin/transaction_log/tests/t/ddl_transaction_id.inc	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/ddl_transaction_id.inc	2010-04-01 16:41:45 +0000
@@ -0,0 +1,29 @@
+# 
+# Tests ordering of transaction ID, that SELECT queries
+# do not increment the transaction ID, and that the proper
+# generation of transaction IDs is done for DDL operations.
+#
+
+--disable_warnings
+DROP TABLE IF EXISTS t1;
+--enable_warnings
+
+CREATE TABLE t1 (
+  id INT NOT NULL PRIMARY KEY
+, padding VARCHAR(200) NOT NULL
+);
+
+INSERT INTO t1 VALUES (1, "I love testing.");
+INSERT INTO t1 VALUES (2, "I hate testing.");
+
+SELECT * FROM t1;
+
+ALTER TABLE t1 CHANGE COLUMN padding less_padding VARCHAR(180) NOT NULL;
+
+# 
+# Should be no result here...
+#
+
+SELECT * FROM t1 WHERE id = 3;
+
+DROP TABLE t1;

=== added file 'plugin/transaction_log/tests/t/ddl_transaction_id.test'
--- plugin/transaction_log/tests/t/ddl_transaction_id.test	1970-01-01 00:00:00 +0000
+++ plugin/transaction_log/tests/t/ddl_transaction_id.test	2010-04-01 16:41:45 +0000
@@ -0,0 +1,14 @@
+# Truncate the log file to reset for the next test
+--source ../plugin/transaction_log/tests/t/truncate_log.inc
+
+--source ../plugin/transaction_log/tests/t/ddl_transaction_id.inc
+
+--replace_column 2 X 7 X 8 X 9 X
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG;
+--replace_column 1 X 3 X
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_ENTRIES;
+--replace_column 1 X 4 X 5 X
+SELECT * FROM DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
+
+# Truncate the log file to reset for the next test
+--source ../plugin/transaction_log/tests/t/truncate_log.inc

